//
//  Csv1.cpp
//
//  Copyright (c) Tomoya Mori. All rights reserved.
//

#include "Csv1.h"

const string Csv1:: separator = "//";              
const string Csv1:: delimiter = ", \n\t";          
const string Csv1:: writeDelimiter = " ";        
const string Csv1:: defaultLabel = "";

Csv1::
Csv1( const vector<string>& source )
{
    operator=( source );
}


Csv1& Csv1::
operator=( const string& inString )
{
    vector<string>::clear();
    
    string data, inLabel;
    //  data = Token( source, Csv1::Separator() );
    
    Separate( inString, data, inLabel, Csv1::Separator() ); 
    // Copy data part to data, and comment part to comment.
    
    Label( inLabel );
    
    string token = Token( data, Delimiter() ); 
    while( token != "" ) // Get Csv elements from data
    {
        push_back( token );
        token = Token( data, Delimiter() );
    }
    
    return *this;
}


istream& Csv1::
Read( istream& is )
{
    unsigned long check_empty_csv1;
    do
    {
        if ( is.peek() == EOF )
            break;
        
        clear();
        string buf;
        getline( is, buf ); 
        // Get string from istream (upto the end of line).
        
        check_empty_csv1 = buf.find(Separator());
        operator=(buf);
    }
    while ( ( Label() == "" && empty() && check_empty_csv1 == string::npos) );
    
    return is;
}


ostream& Csv1::
Write( ostream& os ) const
{
    string ret, tmp;
    
    if ( size() > 0 )
    {
        for ( int i = 0; i < size(); ++i )
        {
            ret += (*this)[i];
        
            if ( i < size() - 1 )
                ret += ",";
        }
    }

    if ( Label() != "" )
        ret += Conversion( tmp, Separator() + Label() ); 

    if ( size() > 0 )
        os << ret << "\n";
    
    return os;
}



