//
//  Csv1.h
//
//  Copyright (c) Tomoya Mori. All rights reserved.
//

#ifndef DetectClusters_Csv1_h
#define DetectClusters_Csv1_h

#include "NamedObjectVector.h"

using namespace std;

class Csv1 : public NamedObjectVector< string >
{
private:
    static const string separator; 
    // Separator between data and comment.
    
    static const string delimiter; 
    // Delimiter separating elements of data in input string. 
    
    static const string writeDelimiter;  
    // Delimiter separating elements of data in output string 
    
    static const string defaultLabel;
    // Default label for Csv1 instance.
    
    //    int column_width;
    
public:
    Csv1( const string inLabel = "" ) : 
	NamedObjectVector<string>( inLabel ) {} 
    Csv1( const Csv1& inCsv ) : 
	NamedObjectVector< string >( inCsv ) {}
    Csv1( const vector<string>& source );
    
    //      Csv1( const string inLabel = "", int clw = LENGTH_DATA ) : 
    //  	NamedObjectVector<string>( inLabel ) { column_width = clw; } 
    //      Csv1( const Csv1& inCsv, int clw = LENGTH_DATA ) : 
    //  	NamedObjectVector< string >( inCsv ) { column_width = clw; }
    //      Csv1( const vector<string>& source, int clw = LENGTH_DATA);
    
    ~Csv1() {};
    
    Csv1& operator=( const string& );
    // Converts a string to Csv1.
    // Label can be specified after delimiter:
    // elm1 ... elm2 // label.
    // Label should not contain ws, otherwise BadLabel exception will be thrown.
    
    ////////// Accessors //////////
    
    static const string& Separator() { return separator; }
    static const string& Delimiter() { return delimiter; }
    static const string& WriteDelimiter() { return writeDelimiter; }
    static const string& DefaultLabel() { return defaultLabel; }
    //    void ColumnWidth( int clw ) { column_width = clw; }
    
    
    ////////// I/O Functions //////////
    
    istream& Read( istream& is );
    // Read until either or both of Label and elements are found,
    // or reach EOF.
    
    ostream& Write( ostream& os ) const;
    //  ostream& Write( ostream& os, int column_width ) const;
};


#endif
