//
//  Distance.h
//
//  Copyright (c) Tomoya Mori. All rights reserved.
//

#ifndef DetectClusters_Distance_h
#define DetectClusters_Distance_h

#include <utility>
#include <map>
#include <iostream>
#include <string>
#include <cfloat>
#include "StringManipulator.h"
#include "Csv1.h"


using namespace std;

class Distance
{
private:
    map<int, map<int, double>* >  data;
    // data[origin][destination] = distance
    
public:
    const map<int, map<int,double>* >& Data() const { return data; }
    
    double operator()(int orig, int dest);
    // Return distance between orig and dest 
    // Automatically resets as orig < dest
    // Throws error if orig is not in the list of all basic regions.
    // Returns DBL_MAX if there is no path from orig to dest
    // i.e., if orig and dest are in disconnected islands.
    
    Distance& operator=( const Distance& in_dist );

    void Read( istream& is );
    // Read interregional distance data into "data".
    // Distance data contains three columns:
    // origin region, destination region, distance
    
 //   void Write( ostream& os );
    // Write the distance data to file in CSV form.
    
    Distance() {}
    ~Distance();
    
};



#endif
