//
//  IndustryLocationData.cpp
//
//  Copyright (c) Tomoya Mori. All rights reserved.
//

#include "IndustryLocationData.h"

void IndustryLocationData:: 
Read( istream& is )
{
    Csv1 line;
    is >> line;
    
    string tmp_str;
    
    /// Read industry IDs ///
    
    for ( int i = 1; i < line.size(); ++i )
    {
        industries.push_back( Conversion(tmp_str, line[i],0) );
    }
    
    double tmp_dbl;
    while ( is.peek() != EOF )
    {
        is >> line;
        int loc;
        Conversion( loc, line[0] );
        // 1st element = basic region ID

        locations.push_back(loc);

        map<string, double>* new_data = new map<string,double>;
        // industry ID -> count
        
        data[loc] = new_data;
        
        for ( int i = 1; i < line.size(); ++i )
        { 
            (*(data[loc]))[industries[i-1]] = 
            Conversion( tmp_dbl, line[i]);
        }
    }
}



IndustryLocationData::
~IndustryLocationData()
{
    for ( map<int, map<string,double>* >::iterator i = data.begin();
         i != data.end(); ++i )
        delete i->second;
}



