//
//  IndustryLocationData.h
//
//  Copyright (c) Tomoya Mori. All rights reserved.
//

#ifndef DetectClusters_IndustryLocationData_h
#define DetectClusters_IndustryLocationData_h

#include <map>
#include <iostream>
#include "StringManipulator.h"
#include "Csv1.h"

using namespace std;

class IndustryLocationData
{
private:
    vector<string> industries;
    // Set of industries.
    
    vector<int> locations;
    // Set of basic regions.
    
    map<int, map<string, double>* > data;
    // Location ID -> Industry ID -> Establishment counts
    
public:
    vector<string>& Industries() { return industries; }
    const vector<int>& Locations() const { return locations; }
    const map<int, map<string,double>* >& Data() const { return data; }
    double Value( int loc, string ind ) { return (*(data[loc]))[ind]; }
    void Read( istream& is );
    // Read industries by basic region matrix of estabishment counts, and
    // initialize "data".
    
    IndustryLocationData() {}
    ~IndustryLocationData();
};



#endif
