//
//  ShortestPathData.cpp
//
//  Copyright (c) Tomoya Mori. All rights reserved.
//


#include "ShortestPathData.h"

void ShortestPathData::
Read( istream& is )
{
    vector< int > regions;
    map< int, vector<int>* > tmp_data;
    
    int tmp_int;
    
    int num = 0;
    
    cout << "\nReading shortest-path data ..." << flush;
    
    
    while ( is.peek() != EOF )
    {
        Csv1 line;
        is >> line;
        int loc;
        Conversion( loc, line[0] );
        regions.push_back( loc );
        
        tmp_data[loc] = new vector<int>;
        
        for ( int i = 1; i < line.size(); ++i )
            tmp_data[loc]->
            push_back( Conversion( tmp_int, line[i] ) );
        
        ++num;
        if ( num % 100 == 0 )
            cout << "." << flush;
    }
    
    cout << endl;
    
    for ( map<int, vector<int>* >::iterator i = tmp_data.begin();
         i != tmp_data.end(); ++i )
    {
        data[ i->first ] = new map< int, int >;
        
        for ( int j = 0; j < regions.size(); ++j )
        {
            (*(data[ i->first ]))[regions[j]] = (*(i->second))[j];
        }
    }
    
    for ( map<int, vector<int>* >::iterator i = tmp_data.begin();
         i != tmp_data.end(); ++i )
    {
        delete i->second;
    }
}

ShortestPathData::
~ShortestPathData()
{
    for ( map<int, map<int, int>* >::iterator i = data.begin();
         i != data.end(); ++i )
    {
        delete i->second;
    }
}
