//
//  ShortestPathData.h
//
//  Copyright (c) Tomoya Mori. All rights reserved.
//
//  This data class contains information to identify the shortest-distance sequence of adjacent basic regions
//  connecting a pair of basic regions.
//
//  
//

#ifndef DetectClusters_ShortestPathData_h
#define DetectClusters_ShortestPathData_h

#include <vector>
#include <map>
#include <iostream>
#include <string>
#include "StringManipulator.h"
#include "Csv1.h"

using namespace std;

class ShortestPathData
{
private:
    map<int, map<int,int>* > data;
    // Location of an origin basic region r -> Location of a destination basic region s
    // -> the first region to pass from region r on the shortest path betwee r and s.
    
public:
    map<int,int>& operator()( int target ) 
    { return *(data[target]); }

    void Read( istream& is );
    // Input : #regions by #regions matrix containing the local move from i-th region to j-th region
    // along the shortest path.
    //
    // 1st element of each row is the origin region.
    // j-th (j >= 1) element of i-th row indicates the local move to (adjacent region) from region i to reach region j along
    // the shortest (region) path.
    
    ShortestPathData() {}
    ~ShortestPathData();
};


#endif
