//
//  main.cpp
//  GenerateRandomLocationData
//
//  Created by 知也 森 on 11/11/24.
//  Copyright (c) 2011年 __MyCompanyName__. All rights reserved.
//

#include <fstream>
#include <utility>
#include <string>
#include <vector>
#include <map>
#include <set>
#include <cmath>
#include <ctime>
#include "Region.h"
#include "Distance.h"
#include "IndustryLocationData.h"
#include "NoFile.h"
#include "CantOpenFile.h"
#include "StringManipulator.h"
#include "Csv1.h"

using namespace std;
typedef map<int, map<string, double>* > loc_source_data;

int main()
{
    try 
    {
        
        cout << "GenerateRandomLocation ..." << endl;
        cout << "\nINPUT  : input_generate_randomlocation.txt" 
        << endl;
        
        ofstream os;
        string tmp_str;
        Csv1 line;
        double tmp_dbl;
        int tmp_int;
        
        
        ifstream is( "./input_generate_randomlocation.txt" );
        
        is >> line;
        int start_id;
        Conversion( start_id, line[0] );
        
        is >> line;
        int end_id;
        Conversion( end_id, line[0] );
        
        is >> line;
        string ind_list_file = line[0];
        
        is >> line;
        int sample_start_id;
        Conversion( sample_start_id, line[0] );
        
        is >> line;
        int sample_end_id;
        Conversion( sample_end_id, line[0] );
        
        is >> line;
        string location_file = line[0];
        
        is >> line;
        string area_file = line[0];
        
        is >> line;
        string out_dir_base = line[0];
        
        is >> line;
        string out_head = line[0];
        
        
        is.close();
        is.clear();
        
        ///// Read industry list /////
        
        vector<string> all_ind;
        is.open( ind_list_file.c_str() );
        
        if (!is) NoFile nf( ind_list_file );
        
        while ( is.peek() != EOF )
        {
            is >> line;
            all_ind.push_back( line[1] );
        }
        is.close();
        is.clear();
        
        ++end_id;
        
        if ( end_id > all_ind.size() )
            end_id = (int) all_ind.size();
        
        vector<string> targets;
        
        for ( int i = start_id; i < end_id; ++i )
        {
            targets.push_back( all_ind[i] );
        }
        
        
        cout << "Target industries : " << targets.front()
        << " - " << targets.back() << endl;
        cout << "Sample start ID  : " << sample_start_id << endl;
        cout << "Sample end ID  : " << sample_end_id << endl;
        cout << "Location data : " << location_file << endl;
        cout << "Area data : " << area_file << endl;
        cout << "OUTPUT Base Dir: " << out_dir_base <<  endl;
        cout << "Output file head: " << out_head << endl;
        
        ///// Read industry location data /////
        
        is.open( location_file.c_str() );
        
        if ( !is ) NoFile nf(location_file);
        
        IndustryLocationData data;
        data.Read(is);
        is.close();
        is.clear();
        
        cout << "\nIndustry location data read ..." << endl;
        
        
        ///// Read area data /////
        
        is.open( area_file.c_str() );
        if ( !is ) NoFile nf(area_file);
        
        set<Region*> regions; 
        // Set of all regions
        
        map<int, Region*> region_id;
        // Region ID -> Region*
        
        double total_area = 0.0;
        // National total area (contiguous)
        
        is >> line;
        // Header
        
        while ( is.peek() != EOF )
        {
            is >> line;
            Conversion(tmp_int,line[0]);
            Conversion(tmp_dbl,line[1]);
            
            total_area += tmp_dbl;
            Region* new_region = new Region( tmp_int, tmp_dbl );
            regions.insert( new_region );
            region_id[tmp_int] = new_region;
            
        }
        is.close();
        is.clear();
        
        for ( set<Region*>::iterator i1 = regions.begin();
             i1 != regions.end(); ++i1 )
        {
            (**i1).SetAreaShare( total_area );
        }
        
        cout << "Area data read ..." << endl;
        
        
        
        ///// Generate random location patterns /////
        
        
        string target_ind;
        string out_dir;
        srand( (unsigned int) time(0) );
        ++sample_end_id;
        
        for ( vector<string>::iterator i0 = targets.begin();
             i0 != targets.end(); ++i0 )
        {
            cout << "Computing for Industry " << *i0 << endl;
            target_ind = *i0;
            
            out_dir = out_dir_base + target_ind + "/";
            
            
            double total_count = 0.0;
            
            for ( set<Region*>::iterator i1 = regions.begin();
                 i1 != regions.end(); ++i1 )
            {
                double new_count = 
                data.Value( (**i1).Location(), target_ind );
                
                total_count += new_count;
            }
            
            if ( total_count == 0.0 )
            {
                cout << "\nNo establishments in the regional system.\n" << endl;
                
                for ( set<Region*>::iterator i1 
                     = regions.begin(); 
                     i1 != regions.end(); ++i1 )
                {
                    (**i1).Count(0.0);
                }
                
                continue;
            }
            
            
            // Set up the region list for random location
            
            vector<Region*> vec_regions;
            vector<double> cummulative_area;
            
            double sum_area = 0.0;
            
            for ( set<Region*>::iterator i1 = regions.begin();
                 i1 != regions.end(); ++i1 )
            {
                sum_area += (**i1).Area();
                vec_regions.push_back( *i1 );
                cummulative_area.push_back( sum_area );
            }
            
            // Initialize the random seed :
            
            string tmp_str;
            
            for ( int i1 = sample_start_id; 
                 i1 != sample_end_id; ++i1 )
            {
                
                for ( int i2 = 0; i2 != (int) total_count; ++i2 )
                {
                    double draw = rand() * total_area / RAND_MAX;
                    
                    for ( int i3 = 0; i3 != cummulative_area.size(); ++i3 )
                    {
                        if ( draw < cummulative_area[i3] )
                        {
                            vec_regions[i3]->SetCount() += 1.0;
                            break;
                        }
                    }
                }
                
                
                string outname = out_dir + out_head + Conversion(tmp_str,*i0,0) 
                + "_" + Conversion(tmp_str,i1,0) + ".csv";
                
                os.open( outname.c_str() );
                
                if (!os) NoFile nf( outname );

                for ( map<int, Region*>::iterator i2 = region_id.begin();
                     i2 != region_id.end(); ++i2 )
                {
                    os << i2->first << ", " << i2->second->Count()<< endl;
                }
                
                os.close();
                os.clear();
                
                
                for ( set<Region*>::iterator i2 = regions.begin(); 
                     i2 != regions.end(); ++i2 )
                {
                    (**i2).Count( 0.0 );
                }
                
                
            }
            
            
            
        }
        
        for ( set<Region*>::iterator i1 = regions.begin(); 
             i1 != regions.end(); ++i1 )
        {
            if ( *i1 != NULL )
                delete *i1;
        }
        cout << "\nDONE !\n";
    }
    
    
    catch ( const string& str )
    {
        cerr << str;
    }
    
    catch ( const char* str )
    {
        cerr << str;
    }
    
    catch ( ... )
    {
        cerr << "\nError: Something is wrong. Cannot figure out.\n";
    }
    
}

