//
//  main.cpp
//  GenerateSpuriousClusters
//
//  Created by 知也 森 on 12/06/29.
//  Copyright (c) 2012年 __MyCompanyName__. All rights reserved.
//


#include <fstream>
#include <utility>
#include <string>
#include <vector>
#include <map>
#include <set>
#include <cmath>
#include <ctime>
#include "Distance.h"
#include "Region.h"
#include "Cluster.h"
#include "ClusterSystem.h"
#include "ClusterBuilder.h"
#include "IndustryLocationData.h"
#include "NoFile.h"
#include "CantOpenFile.h"
#include "StringManipulator.h"
#include "Csv1.h"

using namespace std;
typedef map<int, map<string, double>* > loc_source_data;

int main()
{
    try 
    {
        
        cout << "GenerateSpuriousClusters ..." << endl;
        cout << "\nINPUT  : input_generate_spuriousclusters.txt"
        << endl;
        
        ofstream os;
        string tmp_str;
        Csv1 line;
        double tmp_dbl;
        int tmp_int;
        
        
        ifstream is( "./input_generate_spuriousclusters.txt" );
        
        is >> line;
        int start_id;
        Conversion( start_id, line[0] );
        
        is >> line;
        int end_id;
        Conversion( end_id, line[0] );
        
        is >> line;
        string ind_list_file = line[0];
        
        is >> line;
        int sample_start_id;
        Conversion( sample_start_id, line[0] );
        
        is >> line;
        int sample_end_id;
        Conversion( sample_end_id, line[0] );
        
//        is >> line;
//        int criterion_choice;
//        Conversion( criterion_choice, line[0] );
        
        is >> line;
        double expand_search_step;
        Conversion( expand_search_step, line[0] );
        
        is >> line;
        string area_file = line[0];
        
        is >> line;
        string neighbors_file = line[0];
        
        is >> line;
        string border_region_file = line[0];
        
        is >> line;
        string distance_file = line[0];
        
        
        is >> line;
        string shortest_path_main_file = line[0];
        
//        is >> line;
//        string shortest_path_hokkaido_file = line[0];
        
        
        //      string shortest_path_file = line[0];
        
        //        is >> line;
        //        string nml_penalty_table_file = line[0];
        
        is >> line;
        string in_base_dir = line[0];
        
        is >> line;
        string out_base_dir = line[0];
        
        is >> line;
        string in_head = line[0];
        
        is.close();
        is.clear();
        
        ///// Read industry list /////
        
        vector<string> all_ind;
        is.open( ind_list_file.c_str() );
        
        if (!is) NoFile nf( ind_list_file );
        
        while ( is.peek() != EOF )
        {
            is >> line;
            all_ind.push_back( line[1] );
        }
        is.close();
        is.clear();
        
        ++end_id;
        
        if ( end_id > all_ind.size() )
            end_id = (int) all_ind.size();
        
        vector<string> targets;
        
        for ( int i = start_id; i < end_id; ++i )
        {
            targets.push_back( all_ind[i] );
        }
        
        
        cout << "Target industries : " << targets.front() << " - " << targets.back() << endl;
//        cout << "Criterion : "   << ClusterBuilder::criterionName[criterion_choice] << endl;
        cout << "Sample start ID  : " << sample_start_id << endl;
        cout << "Sample end ID  : " << sample_end_id << endl;
        cout << "Expand_search_step  : " << expand_search_step << endl;
        //      cout << "Location data : " << location_file << endl;
        cout << "Area data : " << area_file << endl;
        cout << "Neighbors data : " << neighbors_file << endl;
        cout << "Distance data : " << distance_file << endl;
        cout << "Border regions data : " << border_region_file << endl << endl;
        
        //        cout << "NML penalty table data : " << nml_penalty_table_file << endl << endl;
        cout << "Input base dir: " << in_base_dir <<  endl;
        
        cout << "input_file_head: " << in_head <<  endl;
        
        cout << "Output base dir: " << out_base_dir <<  endl;      
        
        ///// Read area data /////
        
        is.open( area_file.c_str() );
        if ( !is ) NoFile nf(area_file);
        
        set<Region*> regions; 
        // Set of all regions
        
        map<int, Region*> region_id;
        // Region ID -> Region*
        
        double total_area = 0.0;
        // National total area (contiguous)
        
        is >> line;
        // Header
        
        while ( is.peek() != EOF )
        {
            is >> line;
            Conversion(tmp_int,line[0]);
            Conversion(tmp_dbl,line[1]);
            
            total_area += tmp_dbl;
            Region* new_region = new Region( tmp_int, tmp_dbl );
            regions.insert( new_region );
            region_id[tmp_int] = new_region;
            
        }
        is.close();
        is.clear();
        
        for ( set<Region*>::iterator i1 = regions.begin();
             i1 != regions.end(); ++i1 )
        {
            (**i1).SetAreaShare( total_area );
        }
        
        cout << "Area data read ..." << endl;
        
        
        ///// Read neighbors data /////
        
        is.open(neighbors_file.c_str() );
        if ( !is ) NoFile nf(neighbors_file);
        
        is >> line;
        
        while ( is.peek() != EOF )
        {
            is >> line;
            int loc; Conversion(loc, line[0]);
            int adjacent; Conversion( adjacent, line[1] );
            region_id[loc]->AddNeighbor( region_id[adjacent] );
        }
        is.close();
        is.clear();
        
        cout << "NeighborsData read ... " << endl;
        
        
        ///// Border regions data /////
        
        is.open( border_region_file.c_str() );
        
        if ( !is ) NoFile nf(border_region_file);
        
        is >> line;
        
        while ( is.peek() != EOF )
        {
            is >> line;
            Conversion(tmp_int,line[0]);
            
            if ( region_id.find(tmp_int) != region_id.end() )
                region_id[tmp_int]->SetBorder();
        }
        is.close();
        is.clear();
        
        cout << "\nBorder regions identified ..." << endl;
        
        ///// Read Distance data /////
        
        Distance distance;
        is.open( distance_file.c_str() );
        if ( !is ) NoFile nf(distance_file);

        is >> line;
        // Header
        
        distance.Read(is);
        is.close();
        is.clear();
        
        cout << "Distance data read ..." << endl;
        
        ///// Read Shortest-path sequence /////
        
        ShortestPathData shortest_path_main_data;
        
        is.open( shortest_path_main_file.c_str() );
        if ( !is ) NoFile nf(shortest_path_main_file);

        is >> line;
        // Header
        
        
        shortest_path_main_data.Read(is);
        is.close();
        is.clear();
        
//        ShortestPathData shortest_path_hokkaido_data;
//        is.open( shortest_path_hokkaido_file.c_str() );
//        shortest_path_hokkaido_data.Read(is);
//        is.close();
//        is.clear();
        
        
        for ( set<Region*>::iterator i = regions.begin();
             i != regions.end(); ++i )
        {
//            if ( (**i).Location() / 1000 > 1 )
            (**i).Read( shortest_path_main_data, region_id );
//            else
//                (**i).Read( shortest_path_hokkaido_data,
//                           region_id );
            
        }
        
        
        
        //       ShortestPathData shortest_path_data;
        
        //       is.open( shortest_path_file.c_str() );
        //       shortest_path_data.Read(is);
        //       is.close();
        //       is.clear();
        
        
        //       for ( set<Region*>::iterator i = regions.begin();
        // 	    i != regions.end(); ++i )
        // 	{
        // 	  (**i).Read( shortest_path_data,
        // 		      region_id );
        // 	}
        
        
        cout << "Shortest-path sequences data read ..." << endl;
        
        //        ///// Read NML table /////
        //        
        //        map<int, vector<double>* > nml_penalty;
        //        
        //        is.open( nml_penalty_table_file.c_str() );
        //        
        //        while ( is.peek() != EOF )
        //        {
        //            is >> line;
        //            int estab_count; Conversion(estab_count, line[0]);
        //            nml_penalty[estab_count] = new vector<double>();
        //            
        //            for ( int i = 1; i < line.size(); ++i )
        //            {
        //                int elm; Conversion( elm, line[i] );
        //                nml_penalty[estab_count]->push_back(elm);
        //            }
        //        }
        //        is.close();
        //        is.clear();
        //        
        //        cout << "NML penalty table read ..." << endl;
        //        
        //        
        
        ///// Generate random location patterns /////
        
        //      const string out_subdir[3] = {"aic", "bic", "nml" };
        
        string target_ind;
        string out_dir, in_dir;
        
        ++sample_end_id;
        
        for ( vector<string>::iterator i0 = targets.begin();
             i0 != targets.end(); ++i0 )
        {
            cout << "Computing for Industry " << *i0 << endl;
            target_ind = *i0;
            
            in_dir = in_base_dir + target_ind + "/";
            
            
            out_dir = out_base_dir +  
            Conversion(tmp_str,target_ind,0) + "/";
            
            string out_test = out_dir + "test";
            
            ofstream os_test( out_test.c_str() );
            if (!os_test) NoFile nf( out_dir );

            
            for ( int i1 = sample_start_id; 
                 i1 != sample_end_id; ++i1 )
            {
                
                string inname = in_dir + in_head + 
                Conversion(tmp_str,*i0,0) + "_" + Conversion(tmp_str, i1, 0)
                + ".csv";
                
                is.open( inname.c_str() );
                if ( !is ) NoFile nf(inname);


                
                double total_count = 0.0;
                
                while ( is.peek() != EOF )
                {
                    Csv1 line;
                    is >> line;
                    int loc;
                    double count;
                    Conversion(loc,line[0]);
                    Conversion(count,line[1]);
                    region_id[loc]->Count(count);
                    total_count += count;
                }
                is.close();
                is.clear();
                
                
                if ( total_count == 0.0 )
                {
                    cout << "\nNo establishments in the regional system.\n" << endl;
                    for ( set<Region*>::iterator i1 
                         = regions.begin(); 
                         i1 != regions.end(); ++i1 )
                    {
                        (**i1).Count(0.0);
                    }
                    
                    continue;
                }
                
                ClusterBuilder builder( //criterion_choice,
                                       &regions,
                                       expand_search_step,
                                       total_area,
                                       total_count,
                                       &distance
                                       //                                       ,
                                       //                                       &nml_penalty
                                       );
                
                builder.SetRandom();
                builder.SetSampleId( i1 );
                builder.SetOS( out_dir );
                builder.SetIndustryId( target_ind );
                //	      builder.SetCriterion( criterion_choice );
                
                builder.SetLogType( ClusterBuilder::_event, true );
                builder.SetLogType( ClusterBuilder::_summary, false );
                builder.SetLogType( ClusterBuilder::_main, true  );
                builder.SetLogType( ClusterBuilder::_map, false );
                
                
                
                if ( builder.IfTakeLog( ClusterBuilder::_event ) )
                    builder.SetEventLog();
                
                
                if ( builder.IfTakeLog( ClusterBuilder:: _main ) )
                    builder.SetCompLog();
                
                //	      builder.InitializeConsolidatedRegionsSingleElement();
                
                builder.GrowSystem();
                
                
                // 	      for ( set<Region*>::iterator i1 
                // 		      = regions.begin(); 
                // 		    i1 != regions.end(); ++i1 )
                // 		{
                // 		  (**i1).Count(0.0);
                // 		}
                
                
            }
            
        }
        
        for ( set<Region*>::iterator i1 = regions.begin(); 
             i1 != regions.end(); ++i1 )
        {
            if ( *i1 != NULL )
                delete *i1;
        }
    }
    
    
    catch ( const string& str )
    {
        cerr << str;
    }
    
    catch ( const char* str )
    {
        cerr << str;
    }
    
    catch ( ... )
    {
        cerr << "\nError: Something is wrong. Cannot figure out.\n";
    }
    
}

