#
# EstabEmpSizeOfClusters.py
#

country = 'jp'
year = '2000'
industry_list = []
#basedir = '../../data/' + country + '/'
basedir = '../DATA/' + country + '/clusters/'
industry_file = basedir + '../industry_list_' + country + '_' + year + '.csv'
estab_file = basedir + '../municipality_establishments_' + country + '_' + year + '.csv'
emp_file = basedir + '../municipality_employment_'  + country + '_' + year + '.csv'
cluster_head = basedir + 'members/cluster_map_ind_'
estabhead = basedir + 'sizes/cluster_estab_size_' 
emphead = basedir + 'sizes/cluster_emp_size_' 
#cluster_head = basedir + 'agglomerations/members/agglomeration_map_'
#estabhead = basedir + 'agglomerations/size/agglomeration_estab_size_' 
#emphead = basedir + 'agglomerations/size/agglomeration_emp_size_' 

import csv, sys, math
### Read industry list ###
infile = open(industry_file,'r')
reader = csv.reader(infile)

industries = []
for row in reader:
	industries.append(str(row[0]))

infile.close

### Read weights ###
infile = open(estab_file,'r')
reader = csv.reader(infile)

titles = map(str,reader.next())
titles.pop(0)
weights_estab = {}
for row in reader:
	data = map(int,row)
	municipality = data.pop(0)
	weights_estab[municipality] = {}
	
	for i in range(len(titles)):
		weights_estab[municipality][titles[i]] = data[i]

infile.close

infile = open(emp_file,'r')
reader = csv.reader(infile)

titles = map(str,reader.next())
titles.pop(0)
weights_emp = {}
for row in reader:
	data = map(int,row)
	municipality = data.pop(0)
	weights_emp[municipality] = {}
	
	for i in range(len(titles)):
		weights_emp[municipality][titles[i]] = data[i]

infile.close

### Read clusters ###

if len(industry_list) > 0:
	industries = industry_list
	
	
for industry in industries:
	clusters = {}
#	inname = cluster_head + industry + '_' + country + '_' + year + '.csv'
	inname = cluster_head + industry + '.csv'
	infile = open(inname,'r')
	reader = csv.reader(infile)
	reader.next()
	centers = []
	
	for row in reader:
		cluster = int(row[0])

		member = int(row[1])
		if ( cluster in clusters ) == False:
			centers.append(cluster)
			clusters[cluster] = []
		
		clusters[cluster].append(member)
	
	infile.close

	### Establishment distribution across clusters ##
	estab = {}

	for cluster in clusters:
		estab[cluster] = 0
		for municipality in clusters[cluster]:
			estab[cluster] += weights_estab[municipality][industry]
			
	total_estab = 0
	for cluster in clusters:
		total_estab += estab[cluster]

	for cluster in clusters:
		estab[cluster] = float(estab[cluster]) / float(total_estab)
		
		
	emp = {}

	for cluster in clusters:
		emp[cluster] = 0
		for municipality in clusters[cluster]:
			emp[cluster] += weights_emp[municipality][industry]
			
	total_emp = 0
	for cluster in clusters:
		total_emp += emp[cluster]

	for cluster in clusters:
		emp[cluster] = float(emp[cluster]) / float(total_emp)

	outname = estabhead + industry + '.csv'
	
	outfile = open(outname,'w')
	writer = csv.writer(outfile)
	
	writer.writerow(['CLUSTER','ESTABLISHMENTS'])
	
	for cluster in centers:
		writer.writerow([cluster,estab[cluster]])
	
	outfile.close
	
	outname = emphead + industry + '.csv'
	
	outfile = open(outname,'w')
	writer = csv.writer(outfile)
	
	writer.writerow(['CLUSTER','EMPLOYMENT'])
	
	for cluster in centers:
		writer.writerow([cluster,emp[cluster]])
	
	outfile.close
	
	