#
# SpuriousnessTest.py
#
country = 'jp'
year = '2000'
num_samples = 1000
filetail = '_' + country + '_' + year + '.csv'
basedir = '../DATA/jp/'
industry_file= basedir + 'industry_list_all' + filetail
log_head = basedir + 'clusters/log/event_log_ind_'
rand_dir = basedir + 'clusters/random/clusters/'
out_bic = basedir + 'clusters/random/spuriousness/bic_random_ind_'
out_pvalue = basedir + 'clusters/random/spuriousness/spuriousness_test' + filetail

import csv, sys, os

infile = open(industry_file,'r')
reader = csv.reader(infile)

industries = []

for row in reader:
    industries.append(str(row[1]))

infile.close

outfile_1 = open(out_pvalue,'w')
writer_1 = csv.writer(outfile_1)

writer_1.writerow(['INDUSTRY', 'PVALUE'])



for industry in industries:
    sys.stdout.write(industry + ' ')
    sys.stdout.flush()
    
    inname = log_head + industry + '.txt'
   
    if not os.path.exists(inname):
        sys.stdout.write('\nSkipping ' + industry + '\n' )
        sys.stdout.flush()
        continue
   
    infile = open(inname,'r')
    lines = infile.readlines()

    data = lines[-1].split()
    bic = float(data[-1])
        
    infile.close
    
    
    random_bic = []
    
    for i in range(1,num_samples+1):
        
        inname = rand_dir + industry + '/event_log_ind_' + industry + '_' + str(i) + '.txt'
        
        
        infile = open(inname,'r')
        lines = infile.readlines()

        if len(lines) == 1:
            value = 0.0
        else:
            data = lines[-1].split()
            value = float(data[-1])
            
        infile.close
        
        random_bic.append(value)
        
    random_bic.sort()
    
    outname = out_bic + industry + filetail
    outfile_2 = open(outname,'w')
    writer_2 = csv.writer(outfile_2)
    
    writer_2.writerow(['BIC'])
    for sample in random_bic:
        writer_2.writerow([sample])
    
    outfile_2.close
    
    
    random_bic.reverse()
    
    pvalue = 0.0
    
    if bic < random_bic[0]:
        for i in range(len(random_bic)):
            if bic > random_bic[i]:
                pvalue = float(i+1) / num_samples
                break
            
    
    writer_1.writerow([industry, pvalue])
    

    
outfile_1.close

print ''


    
    
    



